public class HamsterProgram extends model.Hamster { public void main() {
	vor();
	int anzahl = zaehleKoerner();
	laufeBisMauer();
	laufeStufen(anzahl);
}

void laufeStufe() {
	linksUm();
	if(vornFrei()) {
		vor();
		rechtsUm();
		if(vornFrei()) {
			vor();
		} else {
			rechtsUm();
			vor();
			linksUm();
		}
	} else {
		rechtsUm();
	}
}

void rechtsUm() {
	linksUm();
	linksUm();
	linksUm();
}

void laufeStufen(int anzahl) {
	for(int i=0; i<anzahl; i++) {
		laufeStufe();
	}
}

void laufeBisMauer() {
	while(vornFrei()) {
		vor();
	}
}

int zaehleKoerner() {
	int anzahl = 0;
	while(kornDa()) {
		anzahl++;
		nimm();
	}
	return anzahl;
}
 }